## dino-im 0.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3)
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
include(ComputeVersion)
if (NOT VERSION_FOUND)
    project(Dino LANGUAGES C)
elseif (VERSION_IS_RELEASE)
    project(Dino VERSION ${VERSION_FULL} LANGUAGES C)
else ()
    project(Dino LANGUAGES C)
    set(PROJECT_VERSION ${VERSION_FULL})
endif ()

# Prepare Plugins
set(DEFAULT_PLUGINS omemo;openpgp;http-files)
foreach (plugin ${DEFAULT_PLUGINS})
    if ("$CACHE{DINO_PLUGIN_ENABLED_${plugin}}" STREQUAL "")
        if (NOT DEFINED DINO_PLUGIN_ENABLED_${plugin}})
            set(DINO_PLUGIN_ENABLED_${plugin} "yes" CACHE BOOL "Enable plugin ${plugin}")
        else ()
            set(DINO_PLUGIN_ENABLED_${plugin} "${DINO_PLUGIN_ENABLED_${plugin}}" CACHE BOOL "Enable plugin ${plugin}" FORCE)
        endif ()
        if (DINO_PLUGIN_ENABLED_${plugin})
            message(STATUS "Enabled plugin: ${plugin}")
        else ()
            message(STATUS "Disabled plugin: ${plugin}")
        endif ()
    endif ()
endforeach (plugin)

if (DISABLED_PLUGINS)
    foreach(plugin ${DISABLED_PLUGINS})
        set(DINO_PLUGIN_ENABLED_${plugin} "no" CACHE BOOL "Enable plugin ${plugin}" FORCE)
        message(STATUS "Disabled plugin: ${plugin}")
    endforeach(plugin)
endif (DISABLED_PLUGINS)

if (ENABLED_PLUGINS)
    foreach(plugin ${ENABLED_PLUGINS})
        set(DINO_PLUGIN_ENABLED_${plugin} "yes" CACHE BOOL "Enable plugin ${plugin}" FORCE)
        message(STATUS "Enabled plugin: ${plugin}")
    endforeach(plugin)
endif (ENABLED_PLUGINS)

set(PLUGINS "")
get_cmake_property(all_variables VARIABLES)
foreach (variable_name ${all_variables})
    if (variable_name MATCHES "^DINO_PLUGIN_ENABLED_(.+)$" AND ${variable_name})
        list(APPEND PLUGINS ${CMAKE_MATCH_1})
    endif()
endforeach ()
list(SORT PLUGINS)
string(REPLACE ";" ", " PLUGINS_TEXT "${PLUGINS}")

message(STATUS "Configuring Dino ${PROJECT_VERSION} with plugins: ${PLUGINS_TEXT}")

# Prepare instal paths
macro(set_path what val desc)
    if (NOT ${what})
        unset(${what} CACHE)
        set(${what} ${val})
    endif ()
    if (NOT "${${what}}" STREQUAL "${_${what}_SET}")
        message(STATUS "${desc}: ${${what}}")
        set(_${what}_SET ${${what}} CACHE INTERNAL ${desc})
    endif()
endmacro(set_path)

string(REGEX REPLACE "^liblib" "lib" LIBDIR_NAME "lib${LIB_SUFFIX}")
set_path(CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}" "Installation directory for architecture-independent files")
set_path(EXEC_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}" "Installation directory for architecture-dependent files")
set_path(SHARE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/share" "Installation directory for read-only architecture-independent data")

set_path(BIN_INSTALL_DIR "${EXEC_INSTALL_PREFIX}/bin" "Installation directory for user executables")
set_path(DATA_INSTALL_DIR "${SHARE_INSTALL_PREFIX}/dino" "Installation directory for dino-specific data")
set_path(APPDATA_FILE_INSTALL_DIR "${SHARE_INSTALL_PREFIX}/metainfo" "Installation directory for .appdata.xml files")
set_path(DESKTOP_FILE_INSTALL_DIR "${SHARE_INSTALL_PREFIX}/applications" "Installation directory for .desktop files")
set_path(SERVICE_FILE_INSTALL_DIR "${SHARE_INSTALL_PREFIX}/dbus-1/services" "Installation directory for .service files")
set_path(ICON_INSTALL_DIR "${SHARE_INSTALL_PREFIX}/icons" "Installation directory for icons")
set_path(INCLUDE_INSTALL_DIR "${EXEC_INSTALL_PREFIX}/include" "Installation directory for C header files")
set_path(LIB_INSTALL_DIR "${EXEC_INSTALL_PREFIX}/${LIBDIR_NAME}" "Installation directory for object code libraries")
set_path(LOCALE_INSTALL_DIR "${SHARE_INSTALL_PREFIX}/locale" "Installation directory for locale files")
set_path(PLUGIN_INSTALL_DIR "${LIB_INSTALL_DIR}/dino/plugins" "Installation directory for dino plugin object code files")
set_path(VAPI_INSTALL_DIR "${SHARE_INSTALL_PREFIX}/vala/vapi" "Installation directory for Vala API files")

set(TARGET_INSTALL LIBRARY DESTINATION ${LIB_INSTALL_DIR} RUNTIME DESTINATION ${BIN_INSTALL_DIR} PUBLIC_HEADER DESTINATION ${INCLUDE_INSTALL_DIR} ARCHIVE DESTINATION ${LIB_INSTALL_DIR})
set(PLUGIN_INSTALL LIBRARY DESTINATION ${PLUGIN_INSTALL_DIR} RUNTIME DESTINATION ${PLUGIN_INSTALL_DIR})

include(CheckCCompilerFlag)
include(CheckCSourceCompiles)

macro(AddCFlagIfSupported list flag)
    string(REGEX REPLACE "[^a-z^A-Z^_^0-9]+" "_" flag_name ${flag})
    check_c_compiler_flag(${flag} COMPILER_SUPPORTS${flag_name})
    if (${COMPILER_SUPPORTS${flag_name}})
        set(${list} "${${list}} ${flag}")
    endif ()
endmacro()

if ("Ninja" STREQUAL ${CMAKE_GENERATOR})
    AddCFlagIfSupported(CMAKE_C_FLAGS -fdiagnostics-color)
endif ()

# Flags for all C files
AddCFlagIfSupported(CMAKE_C_FLAGS -Wall)
AddCFlagIfSupported(CMAKE_C_FLAGS -Wextra)
AddCFlagIfSupported(CMAKE_C_FLAGS -Werror=format-security)
AddCFlagIfSupported(CMAKE_C_FLAGS -Wno-duplicate-decl-specifier)

if (NOT VALA_WARN)
  set(VALA_WARN "conversion")
endif ()
set(VALA_WARN "${VALA_WARN}" CACHE STRING "Which warnings to show when invoking C compiler on Vala compiler output")
set_property(CACHE VALA_WARN PROPERTY STRINGS "all;unused;qualifier;conversion;deprecated;format;none")

# Vala generates some unused stuff
if (NOT ("all" IN_LIST VALA_WARN OR "unused" IN_LIST VALA_WARN))
    AddCFlagIfSupported(VALA_CFLAGS -Wno-unused-but-set-variable)
    AddCFlagIfSupported(VALA_CFLAGS -Wno-unused-function)
    AddCFlagIfSupported(VALA_CFLAGS -Wno-unused-label)
    AddCFlagIfSupported(VALA_CFLAGS -Wno-unused-parameter)
    AddCFlagIfSupported(VALA_CFLAGS -Wno-unused-value)
    AddCFlagIfSupported(VALA_CFLAGS -Wno-unused-variable)
endif ()

if (NOT ("all" IN_LIST VALA_WARN OR "qualifier" IN_LIST VALA_WARN))
    AddCFlagIfSupported(VALA_CFLAGS -Wno-discarded-qualifiers)
    AddCFlagIfSupported(VALA_CFLAGS -Wno-discarded-array-qualifiers)
endif ()

if (NOT ("all" IN_LIST VALA_WARN OR "deprecated" IN_LIST VALA_WARN))
    AddCFlagIfSupported(VALA_CFLAGS -Wno-deprecated-declarations)
endif ()

if (NOT ("all" IN_LIST VALA_WARN OR "format" IN_LIST VALA_WARN))
    AddCFlagIfSupported(VALA_CFLAGS -Wno-missing-braces)
endif ()

if (NOT ("all" IN_LIST VALA_WARN OR "conversion" IN_LIST VALA_WARN))
    AddCFlagIfSupported(VALA_CFLAGS -Wno-int-conversion)
    AddCFlagIfSupported(VALA_CFLAGS -Wno-pointer-sign)
    AddCFlagIfSupported(VALA_CFLAGS -Wno-incompatible-pointer-types)
endif ()

try_compile(__WITHOUT_FILE_OFFSET_BITS_64 ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_SOURCE_DIR}/cmake/LargeFileOffsets.c COMPILE_DEFINITIONS ${CMAKE_REQUIRED_DEFINITIONS})
if (NOT __WITHOUT_FILE_OFFSET_BITS_64)
    try_compile(__WITH_FILE_OFFSET_BITS_64 ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_SOURCE_DIR}/cmake/LargeFileOffsets.c COMPILE_DEFINITIONS ${CMAKE_REQUIRED_DEFINITIONS} -D_FILE_OFFSET_BITS=64)

    if (__WITH_FILE_OFFSET_BITS_64)
        AddCFlagIfSupported(CMAKE_C_FLAGS -D_FILE_OFFSET_BITS=64)
        message(STATUS "Enabled large file support using _FILE_OFFSET_BITS=64")
    else (__WITH_FILE_OFFSET_BITS_64)
        message(STATUS "Large file support not available")
    endif (__WITH_FILE_OFFSET_BITS_64)
    unset(__WITH_FILE_OFFSET_BITS_64)
endif (NOT __WITHOUT_FILE_OFFSET_BITS_64)
unset(__WITHOUT_FILE_OFFSET_BITS_64)

if ($ENV{USE_CCACHE})
    # Configure CCache if available
    find_program(CCACHE_BIN ccache)
    mark_as_advanced(CCACHE_BIN)
    if (CCACHE_BIN)
        message(STATUS "Using ccache")
        set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE_BIN})
        set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ${CCACHE_BIN})
    else (CCACHE_BIN)
        message(STATUS "USE_CCACHE was set but ccache was not found")
    endif (CCACHE_BIN)
endif ($ENV{USE_CCACHE})

if (NOT NO_DEBUG)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g")
    set(CMAKE_VALA_FLAGS "${CMAKE_VALA_FLAGS} -g")
endif (NOT NO_DEBUG)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

set(GTK3_GLOBAL_VERSION 3.22)
set(GLib_GLOBAL_VERSION 2.38)
set(ICU_GLOBAL_VERSION 57)

if (NOT VALA_EXECUTABLE)
    unset(VALA_EXECUTABLE CACHE)
endif ()

find_package(Vala 0.34 REQUIRED)
if (VALA_VERSION VERSION_GREATER "0.34.90" AND VALA_VERSION VERSION_LESS "0.36.1" OR # Due to a bug on 0.36.0 (and pre-releases), we need to disable FAST_VAPI
        VALA_VERSION VERSION_EQUAL "0.44.10" OR VALA_VERSION VERSION_EQUAL "0.46.4" OR VALA_VERSION VERSION_EQUAL "0.47.1" OR # See Dino issue #646
        VALA_VERSION VERSION_EQUAL "0.40.21" OR VALA_VERSION VERSION_EQUAL "0.46.8" OR VALA_VERSION VERSION_EQUAL "0.48.4") # See Dino issue #816
    set(DISABLE_FAST_VAPI yes)
endif ()

include(${VALA_USE_FILE})
include(MultiFind)
include(GlibCompileResourcesSupport)

set(CMAKE_VALA_FLAGS "${CMAKE_VALA_FLAGS} --target-glib=${GLib_GLOBAL_VERSION}")

add_subdirectory(qlite)
add_subdirectory(xmpp-vala)
add_subdirectory(libdino)
add_subdirectory(main)
add_subdirectory(plugins)

# uninstall target
configure_file("${CMAKE_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in" "${CMAKE_BINARY_DIR}/cmake_uninstall.cmake" IMMEDIATE @ONLY)
add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P ${CMAKE_BINARY_DIR}/cmake_uninstall.cmake COMMENT "Uninstall the project...")

=== libdino/CMakeLists.txt ===
find_packages(LIBDINO_PACKAGES REQUIRED
    GDKPixbuf2
    Gee
    GLib
    GModule
    GObject
)

vala_precompile(LIBDINO_VALA_C
SOURCES
    src/application.vala

    src/dbus/login1.vala
    src/dbus/upower.vala

    src/entity/account.vala
    src/entity/conversation.vala
    src/entity/encryption.vala
    src/entity/file_transfer.vala
    src/entity/message.vala
    src/entity/settings.vala

    src/plugin/interfaces.vala
    src/plugin/loader.vala
    src/plugin/registry.vala

    src/service/avatar_manager.vala
    src/service/blocking_manager.vala
    src/service/chat_interaction.vala
    src/service/connection_manager.vala
    src/service/content_item_store.vala
    src/service/conversation_manager.vala
    src/service/counterpart_interaction_manager.vala
    src/service/database.vala
    src/service/entity_capabilities_storage.vala
    src/service/entity_info.vala
    src/service/file_manager.vala
    src/service/jingle_file_transfers.vala
    src/service/message_correction.vala
    src/service/message_processor.vala
    src/service/message_storage.vala
    src/service/module_manager.vala
    src/service/muc_manager.vala
    src/service/notification_events.vala
    src/service/presence_manager.vala
    src/service/registration.vala
    src/service/roster_manager.vala
    src/service/search_processor.vala
    src/service/stream_interactor.vala
    src/service/util.vala

    src/util.vala
CUSTOM_VAPIS
    "${CMAKE_BINARY_DIR}/exports/xmpp-vala.vapi"
    "${CMAKE_BINARY_DIR}/exports/qlite.vapi"
CUSTOM_DEPS
    xmpp-vala
    qlite
PACKAGES
    ${LIBDINO_PACKAGES}
GENERATE_VAPI
    dino
GENERATE_HEADER
    dino
)

add_custom_command(OUTPUT "${CMAKE_BINARY_DIR}/exports/dino_i18n.h"
COMMAND
    cp "${CMAKE_CURRENT_SOURCE_DIR}/src/dino_i18n.h" "${CMAKE_BINARY_DIR}/exports/dino_i18n.h"
DEPENDS
    "${CMAKE_CURRENT_SOURCE_DIR}/src/dino_i18n.h"
COMMENT
    Copy header file dino_i18n.h
)

add_custom_target(dino-vapi
DEPENDS
    ${CMAKE_BINARY_DIR}/exports/dino.vapi
    ${CMAKE_BINARY_DIR}/exports/dino.deps
    ${CMAKE_BINARY_DIR}/exports/dino_i18n.h
)

add_definitions(${VALA_CFLAGS} -DDINO_SYSTEM_PLUGIN_DIR="${PLUGIN_INSTALL_DIR}" -DDINO_SYSTEM_LIBDIR_NAME="${LIBDIR_NAME}" -DG_LOG_DOMAIN="libdino")
add_library(libdino SHARED ${LIBDINO_VALA_C} ${CMAKE_BINARY_DIR}/exports/dino_i18n.h)
add_dependencies(libdino dino-vapi)
target_link_libraries(libdino xmpp-vala qlite ${LIBDINO_PACKAGES} m)
set_target_properties(libdino PROPERTIES PREFIX "" VERSION 0.0 SOVERSION 0)

install(TARGETS libdino ${TARGET_INSTALL})
install(FILES ${CMAKE_BINARY_DIR}/exports/dino.vapi ${CMAKE_BINARY_DIR}/exports/dino.deps DESTINATION ${VAPI_INSTALL_DIR})
install(FILES ${CMAKE_BINARY_DIR}/exports/dino.h ${CMAKE_BINARY_DIR}/exports/dino_i18n.h DESTINATION ${INCLUDE_INSTALL_DIR})

=== main/CMakeLists.txt ===
set(GETTEXT_PACKAGE "dino")
find_package(Gettext)
include(${GETTEXT_USE_FILE})
gettext_compile(${GETTEXT_PACKAGE} SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/po TARGET_NAME ${GETTEXT_PACKAGE}-translations)

find_packages(MAIN_PACKAGES REQUIRED
    Gee
    GLib
    GModule
    GObject
    GTK3
    ICU
)

set(RESOURCE_LIST
    icons/dino-changes-allowed-symbolic.svg
    icons/dino-changes-prevent-symbolic.svg
    icons/dino-conversation-list-placeholder-arrow.svg
    icons/dino-double-tick-symbolic.svg
    icons/dino-emoticon-symbolic.svg
    icons/dino-qr-code-symbolic.svg
    icons/dino-security-high-symbolic.svg
    icons/dino-party-popper-symbolic.svg
    icons/dino-status-away.svg
    icons/dino-status-chat.svg
    icons/dino-status-dnd.svg
    icons/dino-status-online.svg
    icons/im.dino.Dino.svg
    icons/im.dino.Dino-symbolic.svg
    icons/dino-tick-symbolic.svg

    icons/dino-device-desktop-symbolic.svg
    icons/dino-device-phone-symbolic.svg

    icons/dino-file-document-symbolic.svg
    icons/dino-file-download-symbolic.svg
    icons/dino-file-image-symbolic.svg
    icons/dino-file-music-symbolic.svg
    icons/dino-file-symbolic.svg
    icons/dino-file-table-symbolic.svg
    icons/dino-file-video-symbolic.svg

    add_conversation/add_contact_dialog.ui
    add_conversation/add_groupchat_dialog.ui
    add_conversation/conference_details_fragment.ui
    add_conversation/list_row.ui
    add_conversation/select_jid_fragment.ui
    chat_input.ui
    contact_details_dialog.ui
    conversation_list_titlebar.ui
    conversation_list_titlebar_csd.ui
    conversation_row.ui
    conversation_view.ui
    file_default_widget.ui
    file_send_overlay.ui
    emojichooser.ui
    global_search.ui
    conversation_content_view/item_metadata_header.ui
    conversation_content_view/view.ui
    manage_accounts/account_row.ui
    manage_accounts/add_account_dialog.ui
    manage_accounts/dialog.ui
    menu_add.ui
    menu_app.ui
    menu_conversation.ui
    menu_encryption.ui
    message_item_widget_edit_mode.ui
    occupant_list.ui
    occupant_list_item.ui
    search_autocomplete.ui
    settings_dialog.ui
    shortcuts.ui
    unified_main_content.ui
    unified_window_placeholder.ui

    theme.css
)

compile_gresources(
    MAIN_GRESOURCES_TARGET
    MAIN_GRESOURCES_XML
    TARGET ${CMAKE_CURRENT_BINARY_DIR}/resources/resources.c
    TYPE EMBED_C
    RESOURCES ${RESOURCE_LIST}
    PREFIX /im/dino/Dino
    SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/data
)

unset(MAIN_EXTRA_OPTIONS)
unset(MAIN_EXTRA_PACKAGES)
find_package(GDK3)
if(GDK3_WITH_X11)
    set(MAIN_EXTRA_OPTIONS ${MAIN_EXTRA_OPTIONS} -D GDK3_WITH_X11)
    set(MAIN_EXTRA_PACKAGES ${MAIN_EXTRA_PACKAGES} gdk-x11-3.0)
endif(GDK3_WITH_X11)
set(MAIN_EXTRA_OPTIONS ${MAIN_EXTRA_OPTIONS} --vapidir=${CMAKE_CURRENT_SOURCE_DIR}/vapi)

vala_precompile(MAIN_VALA_C
SOURCES
    src/main.vala

    src/ui/application.vala
    src/ui/avatar_drawer.vala
    src/ui/avatar_image.vala
    src/ui/conversation_list_titlebar.vala
    src/ui/conversation_view.vala
    src/ui/conversation_view_controller.vala
    src/ui/file_send_overlay.vala
    src/ui/global_search.vala
    src/ui/notifications.vala
    src/ui/settings_dialog.vala
    src/ui/main_window.vala
    src/ui/main_window_controller.vala

    src/ui/add_conversation/add_conference_dialog.vala
    src/ui/add_conversation/add_contact_dialog.vala
    src/ui/add_conversation/add_groupchat_dialog.vala
    src/ui/add_conversation/conference_details_fragment.vala
    src/ui/add_conversation/conference_list.vala
    src/ui/add_conversation/list_row.vala
    src/ui/add_conversation/roster_list.vala
    src/ui/add_conversation/select_contact_dialog.vala
    src/ui/add_conversation/select_jid_fragment.vala

    src/ui/chat_input/chat_input_controller.vala
    src/ui/chat_input/chat_text_view.vala
    src/ui/chat_input/edit_history.vala
    src/ui/chat_input/encryption_button.vala
    src/ui/chat_input/occupants_tab_completer.vala
    src/ui/chat_input/smiley_converter.vala
    src/ui/chat_input/view.vala

    src/ui/contact_details/blocking_provider.vala
    src/ui/contact_details/settings_provider.vala
    src/ui/contact_details/permissions_provider.vala
    src/ui/contact_details/dialog.vala
    src/ui/contact_details/muc_config_form_provider.vala

    src/ui/conversation_selector/conversation_selector_row.vala
    src/ui/conversation_selector/conversation_selector.vala

    src/ui/conversation_content_view/chat_state_populator.vala
    src/ui/conversation_content_view/content_populator.vala
    src/ui/conversation_content_view/conversation_item_skeleton.vala
    src/ui/conversation_content_view/conversation_view.vala
    src/ui/conversation_content_view/date_separator_populator.vala
    src/ui/conversation_content_view/file_default_widget.vala
    src/ui/conversation_content_view/file_image_widget.vala
    src/ui/conversation_content_view/file_widget.vala
    src/ui/conversation_content_view/message_widget.vala
    src/ui/conversation_content_view/subscription_notification.vala

    src/ui/conversation_titlebar/menu_entry.vala
    src/ui/conversation_titlebar/occupants_entry.vala
    src/ui/conversation_titlebar/search_entry.vala
    src/ui/conversation_titlebar/conversation_titlebar.vala

    src/ui/manage_accounts/account_row.vala
    src/ui/manage_accounts/add_account_dialog.vala
    src/ui/manage_accounts/dialog.vala

    src/ui/occupant_menu/list.vala
    src/ui/occupant_menu/list_row.vala
    src/ui/occupant_menu/view.vala

    src/ui/util/accounts_combo_box.vala
    src/ui/util/config.vala
    src/ui/util/data_forms.vala
    src/ui/util/helper.vala
    src/ui/util/label_hybrid.vala
    src/ui/util/sizing_bin.vala
    src/ui/util/size_request_box.vala
    src/ui/util/scaling_image.vala
    src/ui/util/preview_file_chooser_native.vala
CUSTOM_VAPIS
    ${CMAKE_BINARY_DIR}/exports/xmpp-vala.vapi
    ${CMAKE_BINARY_DIR}/exports/qlite.vapi
    ${CMAKE_BINARY_DIR}/exports/dino_internal.vapi
    vapi/emojichooser.vapi
PACKAGES
    ${MAIN_PACKAGES}
    ${MAIN_EXTRA_PACKAGES}
GRESOURCES
    ${MAIN_GRESOURCES_XML}
OPTIONS
    ${MAIN_EXTRA_OPTIONS}
)

add_definitions(${VALA_CFLAGS} -DGETTEXT_PACKAGE=\"${GETTEXT_PACKAGE}\" -DLOCALE_INSTALL_DIR=\"${LOCALE_INSTALL_DIR}\" -DDINO_VERSION=\"${PROJECT_VERSION}\")
add_executable(dino ${MAIN_VALA_C} ${MAIN_GRESOURCES_TARGET} src/emojichooser.c)
add_dependencies(dino ${GETTEXT_PACKAGE}-translations)
target_include_directories(dino PRIVATE src)
target_link_libraries(dino libdino ${MAIN_PACKAGES})

if(WIN32)
    target_link_libraries(dino -mwindows)
endif(WIN32)

install(TARGETS dino ${TARGET_INSTALL})
install(FILES data/im.dino.Dino.appdata.xml DESTINATION ${APPDATA_FILE_INSTALL_DIR})
install(FILES data/im.dino.Dino.desktop DESTINATION ${DESKTOP_FILE_INSTALL_DIR})
install(FILES data/im.dino.Dino.service DESTINATION ${SERVICE_FILE_INSTALL_DIR})
install(FILES data/icons/im.dino.Dino.svg DESTINATION ${ICON_INSTALL_DIR}/hicolor/scalable/apps)
install(FILES data/icons/im.dino.Dino-symbolic.svg DESTINATION ${ICON_INSTALL_DIR}/hicolor/symbolic/apps)
install(FILES
    data/icons/dino-status-away.svg
    data/icons/dino-status-chat.svg
    data/icons/dino-status-dnd.svg
    data/icons/dino-status-online.svg

    data/icons/dino-changes-prevent-symbolic.svg
    data/icons/dino-double-tick-symbolic.svg
    data/icons/dino-qr-code-symbolic.svg
    data/icons/dino-tick-symbolic.svg
DESTINATION
    ${ICON_INSTALL_DIR}/hicolor/scalable/status
)

=== xmpp-vala/CMakeLists.txt ===
find_packages(ENGINE_PACKAGES REQUIRED
    GDKPixbuf2
    Gee
    GIO
    GLib
    GObject
    ICU
)

set(ENGINE_DEFINITIONS "")

find_package(GIO)
if(GIO_VERSION VERSION_GREATER "2.60")
    message(STATUS "ALPN support enabled")
    set(ENGINE_DEFINITIONS ALPN_SUPPORT)
else()
    message(STATUS "No ALPN support, needs GIO >= 2.60")
endif()
set(ENGINE_EXTRA_OPTIONS ${MAIN_EXTRA_OPTIONS} --vapidir=${CMAKE_CURRENT_SOURCE_DIR}/vapi)

vala_precompile(ENGINE_VALA_C
SOURCES
    "src/core/namespace_state.vala"
    "src/core/stanza_attribute.vala"
    "src/core/stanza_node.vala"
    "src/core/stanza_reader.vala"
    "src/core/stanza_writer.vala"
    "src/core/xmpp_log.vala"
    "src/core/xmpp_stream.vala"

    "src/module/bind.vala"
    "src/module/bookmarks_provider.vala"
    "src/module/conference.vala"
    "src/module/iq/module.vala"
    "src/module/iq/stanza.vala"
    "src/module/jid.vala"
    "src/module/message/module.vala"
    "src/module/message/stanza.vala"
    "src/module/presence/flag.vala"
    "src/module/presence/module.vala"
    "src/module/presence/stanza.vala"
    "src/module/roster/flag.vala"
    "src/module/roster/item.vala"
    "src/module/roster/module.vala"
    "src/module/roster/versioning_module.vala"
    "src/module/sasl.vala"
    "src/module/session.vala"
    "src/module/stanza.vala"
    "src/module/stanza_error.vala"
    "src/module/stream_error.vala"
    "src/module/tls.vala"
    "src/module/util.vala"

    "src/module/xep/0048_bookmarks.vala"
    "src/module/xep/0048_conference.vala"
    "src/module/xep/0402_bookmarks2.vala"
    "src/module/xep/0004_data_forms.vala"
    "src/module/xep/0030_service_discovery/flag.vala"
    "src/module/xep/0030_service_discovery/identity.vala"
    "src/module/xep/0030_service_discovery/info_result.vala"
    "src/module/xep/0030_service_discovery/item.vala"
    "src/module/xep/0030_service_discovery/items_result.vala"
    "src/module/xep/0030_service_discovery/module.vala"
    "src/module/xep/0045_muc/flag.vala"
    "src/module/xep/0045_muc/module.vala"
    "src/module/xep/0045_muc/status_code.vala"
    "src/module/xep/0047_in_band_bytestreams.vala"
    "src/module/xep/0049_private_xml_storage.vala"
    "src/module/xep/0054_vcard/module.vala"
    "src/module/xep/0060_pubsub.vala"
    "src/module/xep/0065_socks5_bytestreams.vala"
    "src/module/xep/0066_out_of_band_data.vala"
    "src/module/xep/0077_in_band_registration.vala"
    "src/module/xep/0082_date_time_profiles.vala"
    "src/module/xep/0084_user_avatars.vala"
    "src/module/xep/0085_chat_state_notifications.vala"
    "src/module/xep/0115_entity_capabilities.vala"
    "src/module/xep/0166_jingle.vala"
    "src/module/xep/0184_message_delivery_receipts.vala"
    "src/module/xep/0191_blocking_command.vala"
    "src/module/xep/0198_stream_management.vala"
    "src/module/xep/0199_ping.vala"
    "src/module/xep/0203_delayed_delivery.vala"
    "src/module/xep/0234_jingle_file_transfer.vala"
    "src/module/xep/0260_jingle_socks5_bytestreams.vala"
    "src/module/xep/0261_jingle_in_band_bytestreams.vala"
    "src/module/xep/0280_message_carbons.vala"
    "src/module/xep/0308_last_message_correction.vala"
    "src/module/xep/0313_message_archive_management.vala"
    "src/module/xep/0333_chat_markers.vala"
    "src/module/xep/0334_message_processing_hints.vala"
    "src/module/xep/0359_unique_stable_stanza_ids.vala"
    "src/module/xep/0363_http_file_upload.vala"
    "src/module/xep/0368_srv_records_tls.vala"
    "src/module/xep/0380_explicit_encryption.vala"
    "src/module/xep/0391_jingle_encrypted_transports.vala"
    "src/module/xep/0410_muc_self_ping.vala"
    "src/module/xep/pixbuf_storage.vala"

    "src/util.vala"
PACKAGES
    ${ENGINE_PACKAGES}
GENERATE_VAPI
    xmpp-vala
GENERATE_HEADER
    xmpp-vala
CUSTOM_VAPIS
    "${CMAKE_CURRENT_SOURCE_DIR}/src/glib_fixes.vapi"
DEFINITIONS
    ${ENGINE_DEFINITIONS}
OPTIONS
    ${ENGINE_EXTRA_OPTIONS}
)

add_custom_target(xmpp-vala-vapi
DEPENDS
    ${CMAKE_BINARY_DIR}/exports/xmpp-vala.vapi
    ${CMAKE_BINARY_DIR}/exports/xmpp-vala.deps
)

add_definitions(${VALA_CFLAGS} -DG_LOG_DOMAIN="xmpp-vala")
add_library(xmpp-vala SHARED ${ENGINE_VALA_C})
add_dependencies(xmpp-vala xmpp-vala-vapi)
target_link_libraries(xmpp-vala ${ENGINE_PACKAGES})
set_target_properties(xmpp-vala PROPERTIES VERSION 0.1 SOVERSION 0)

install(TARGETS xmpp-vala ${TARGET_INSTALL})
install(FILES ${CMAKE_BINARY_DIR}/exports/xmpp-vala.vapi ${CMAKE_BINARY_DIR}/exports/xmpp-vala.deps DESTINATION ${VAPI_INSTALL_DIR})
install(FILES ${CMAKE_BINARY_DIR}/exports/xmpp-vala.h DESTINATION ${INCLUDE_INSTALL_DIR})

if(BUILD_TESTS)
    vala_precompile(ENGINE_TEST_VALA_C
    SOURCES
        "tests/common.vala"
        "tests/testcase.vala"

        "tests/jid.vala"
        "tests/stanza.vala"
        "tests/util.vala"
    CUSTOM_VAPIS
        ${CMAKE_BINARY_DIR}/exports/xmpp-vala_internal.vapi
    PACKAGES
        ${ENGINE_PACKAGES}
    OPTIONS
        ${ENGINE_EXTRA_OPTIONS}
    )

    add_definitions(${VALA_CFLAGS})
    add_executable(xmpp-vala-test ${ENGINE_TEST_VALA_C})
    target_link_libraries(xmpp-vala-test xmpp-vala ${SIGNAL_PROTOCOL_PACKAGES})
endif(BUILD_TESTS)

=== plugins/http-files/CMakeLists.txt ===
find_packages(HTTP_FILES_PACKAGES REQUIRED
    Gee
    GLib
    GModule
    GObject
    GTK3
    Soup
)

vala_precompile(HTTP_FILES_VALA_C
SOURCES
    src/file_provider.vala
    src/file_sender.vala
    src/message_filter.vala
    src/plugin.vala
    src/register_plugin.vala
CUSTOM_VAPIS
    ${CMAKE_BINARY_DIR}/exports/xmpp-vala.vapi
    ${CMAKE_BINARY_DIR}/exports/dino.vapi
    ${CMAKE_BINARY_DIR}/exports/qlite.vapi
PACKAGES
    ${HTTP_FILES_PACKAGES}
)

add_definitions(${VALA_CFLAGS})
add_library(http-files SHARED ${HTTP_FILES_VALA_C})
target_link_libraries(http-files libdino ${HTTP_FILES_PACKAGES})
set_target_properties(http-files PROPERTIES PREFIX "")
set_target_properties(http-files PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins/)

install(TARGETS http-files ${PLUGIN_INSTALL})

=== plugins/omemo/CMakeLists.txt ===
set(GETTEXT_PACKAGE "dino-omemo")
find_package(Gettext)
include(${GETTEXT_USE_FILE})
gettext_compile(${GETTEXT_PACKAGE} SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/po TARGET_NAME ${GETTEXT_PACKAGE}-translations)

find_packages(OMEMO_PACKAGES REQUIRED
    Gee
    GLib
    GModule
    GObject
    GTK3
    Soup
    Qrencode
)

set(RESOURCE_LIST
    contact_details_dialog.ui
    manage_key_dialog.ui
)

compile_gresources(
    OMEMO_GRESOURCES_TARGET
    OMEMO_GRESOURCES_XML
    TARGET ${CMAKE_CURRENT_BINARY_DIR}/resources/resources.c
    TYPE EMBED_C
    RESOURCES ${RESOURCE_LIST}
    PREFIX /im/dino/Dino/omemo
    SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/data
)

vala_precompile(OMEMO_VALA_C
SOURCES
    src/plugin.vala
    src/register_plugin.vala
    src/trust_level.vala

    src/file_transfer/file_decryptor.vala
    src/file_transfer/file_encryptor.vala
    src/jingle/jingle_helper.vala
    src/jingle/jet_omemo.vala

    src/logic/database.vala
    src/logic/encrypt_state.vala
    src/logic/manager.vala
    src/logic/pre_key_store.vala
    src/logic/session_store.vala
    src/logic/signed_pre_key_store.vala
    src/logic/trust_manager.vala

    src/protocol/bundle.vala
    src/protocol/message_flag.vala
    src/protocol/stream_module.vala

    src/ui/account_settings_entry.vala
    src/ui/account_settings_widget.vala
    src/ui/bad_messages_populator.vala
    src/ui/contact_details_provider.vala
    src/ui/contact_details_dialog.vala
    src/ui/device_notification_populator.vala
    src/ui/own_notifications.vala
    src/ui/encryption_list_entry.vala
    src/ui/manage_key_dialog.vala
    src/ui/util.vala
CUSTOM_VAPIS
    ${CMAKE_BINARY_DIR}/exports/crypto-vala.vapi
    ${CMAKE_BINARY_DIR}/exports/signal-protocol.vapi
    ${CMAKE_BINARY_DIR}/exports/xmpp-vala.vapi
    ${CMAKE_BINARY_DIR}/exports/qlite.vapi
    ${CMAKE_BINARY_DIR}/exports/dino.vapi
PACKAGES
    ${OMEMO_PACKAGES}
GRESOURCES
    ${OMEMO_GRESOURCES_XML}
OPTIONS
    --vapidir=${CMAKE_CURRENT_SOURCE_DIR}/vapi
)

add_definitions(${VALA_CFLAGS} -DGETTEXT_PACKAGE=\"${GETTEXT_PACKAGE}\" -DLOCALE_INSTALL_DIR=\"${LOCALE_INSTALL_DIR}\"  -DG_LOG_DOMAIN="OMEMO")
add_library(omemo SHARED ${OMEMO_VALA_C} ${OMEMO_GRESOURCES_TARGET})
add_dependencies(omemo ${GETTEXT_PACKAGE}-translations)
target_link_libraries(omemo libdino signal-protocol-vala crypto-vala ${OMEMO_PACKAGES})
set_target_properties(omemo PROPERTIES PREFIX "")
set_target_properties(omemo PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/plugins/)

install(TARGETS omemo ${PLUGIN_INSTALL})

=== plugins/signal-protocol/CMakeLists.txt ===
find_package(GCrypt REQUIRED)
find_packages(SIGNAL_PROTOCOL_PACKAGES REQUIRED
    Gee
    GLib
    GObject
)

vala_precompile(SIGNAL_PROTOCOL_VALA_C
SOURCES
    "src/context.vala"
    "src/simple_iks.vala"
    "src/simple_ss.vala"
    "src/simple_pks.vala"
    "src/simple_spks.vala"
    "src/store.vala"
    "src/util.vala"
CUSTOM_VAPIS
    ${CMAKE_CURRENT_SOURCE_DIR}/vapi/signal-protocol-public.vapi
    ${CMAKE_CURRENT_SOURCE_DIR}/vapi/signal-protocol-native.vapi
PACKAGES
    ${SIGNAL_PROTOCOL_PACKAGES}
GENERATE_VAPI
    signal-protocol-vala
GENERATE_HEADER
    signal-protocol-vala
)

set(C_HEADERS_SRC "")
set(C_HEADERS_TARGET "")

if(NOT BUILD_LIBSIGNAL_IN_TREE)
    # libsignal-protocol-c has a history of breaking compatibility on the patch level
    # we'll have to check compatibility for every new release
    # distro maintainers may update this dependency after compatibility tests
    find_package(SignalProtocol 2.3.2 REQUIRED)
else()
    add_subdirectory(libsignal-protocol-c EXCLUDE_FROM_ALL)
    set_property(TARGET curve25519 PROPERTY POSITION_INDEPENDENT_CODE ON)
    set_property(TARGET protobuf-c PROPERTY POSITION_INDEPENDENT_CODE ON)
    set_property(TARGET signal-protocol-c PROPERTY POSITION_INDEPENDENT_CODE ON)

    set(SIGNAL_PROTOCOL_C_HEADERS
        signal_protocol.h
        signal_protocol_types.h
        curve.h
        hkdf.h
        ratchet.h
        protocol.h
        session_state.h
        session_record.h
        session_pre_key.h
        session_builder.h
        session_cipher.h
        key_helper.h
        sender_key.h
        sender_key_state.h
        sender_key_record.h
        group_session_builder.h
        group_cipher.h
        fingerprint.h
        device_consistency.h
    )

    file(MAKE_DIRECTORY "${CMAKE_BINARY_DIR}/exports/signal")

    foreach(f ${SIGNAL_PROTOCOL_C_HEADERS})
        list(APPEND C_HEADERS_SRC "${CMAKE_CURRENT_SOURCE_DIR}/libsignal-protocol-c/src/${f}")
        list(APPEND C_HEADERS_TARGET "${CMAKE_BINARY_DIR}/exports/signal/${f}")
        add_custom_command(OUTPUT "${CMAKE_BINARY_DIR}/exports/signal/${f}"
        COMMAND
            cp "${CMAKE_CURRENT_SOURCE_DIR}/libsignal-protocol-c/src/${f}" "${CMAKE_BINARY_DIR}/exports/signal/${f}"
        DEPENDS
            "${CMAKE_CURRENT_SOURCE_DIR}/libsignal-protocol-c/src/${f}"
        COMMENT
            Copy header file signal/${f}
        )
    endforeach(f)
endif()

list(APPEND C_HEADERS_SRC "${CMAKE_CURRENT_SOURCE_DIR}/src/signal_helper.h")
list(APPEND C_HEADERS_TARGET "${CMAKE_BINARY_DIR}/exports/signal_helper.h")

add_custom_command(OUTPUT "${CMAKE_BINARY_DIR}/exports/signal_helper.h"
COMMAND
    cp "${CMAKE_CURRENT_SOURCE_DIR}/src/signal_helper.h" "${CMAKE_BINARY_DIR}/exports/signal_helper.h"
DEPENDS
    "${CMAKE_CURRENT_SOURCE_DIR}/src/signal_helper.h"
COMMENT
    Copy header file signal_helper.h
)

add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/exports/signal-protocol.vapi
COMMAND
    cat "${CMAKE_CURRENT_SOURCE_DIR}/vapi/signal-protocol-public.vapi" "${CMAKE_BINARY_DIR}/exports/signal-protocol-vala.vapi" > "${CMAKE_BINARY_DIR}/exports/signal-protocol.vapi"
DEPENDS
    ${CMAKE_CURRENT_SOURCE_DIR}/vapi/signal-protocol-public.vapi
    ${CMAKE_BINARY_DIR}/exports/signal-protocol-vala.vapi
)

add_custom_target(signal-protocol-vapi
DEPENDS
    ${CMAKE_BINARY_DIR}/exports/signal-protocol.vapi
    ${CMAKE_BINARY_DIR}/exports/signal-protocol-vala.h
    ${C_HEADERS_TARGET}
)

set(CFLAGS ${VALA_CFLAGS} -I${CMAKE_CURRENT_SOURCE_DIR}/libsignal-protocol-c/src -I${CMAKE_CURRENT_SOURCE_DIR}/src)
add_definitions(${CFLAGS})
add_library(signal-protocol-vala ${SIGNAL_PROTOCOL_VALA_C} ${CMAKE_CURRENT_SOURCE_DIR}/src/signal_helper.c)
add_dependencies(signal-protocol-vala signal-protocol-vapi)
target_link_libraries(signal-protocol-vala ${SIGNAL_PROTOCOL_PACKAGES} gcrypt signal-protocol-c m)
set_property(TARGET signal-protocol-vala PROPERTY POSITION_INDEPENDENT_CODE ON)

if(BUILD_TESTS)
    vala_precompile(SIGNAL_TEST_VALA_C
    SOURCES
        "tests/common.vala"
        "tests/testcase.vala"

        "tests/curve25519.vala"
        "tests/hkdf.vala"
        "tests/session_builder.vala"
    CUSTOM_VAPIS
        ${CMAKE_BINARY_DIR}/exports/signal-protocol-vala_internal.vapi
        ${CMAKE_CURRENT_SOURCE_DIR}/vapi/signal-protocol-public.vapi
        ${CMAKE_CURRENT_SOURCE_DIR}/vapi/signal-protocol-native.vapi
    PACKAGES
        ${SIGNAL_PROTOCOL_PACKAGES}
    )

    set(CFLAGS ${VALA_CFLAGS} -I${CMAKE_CURRENT_BINARY_DIR}/signal-protocol)
    add_executable(signal-protocol-vala-test ${SIGNAL_TEST_VALA_C})
    add_dependencies(signal-protocol-vala-test signal-protocol-vala)
    target_link_libraries(signal-protocol-vala-test signal-protocol-vala ${SIGNAL_PROTOCOL_PACKAGES})
endif(BUILD_TESTS)

=== debian/changelog ===
dino-im (0.2.0-3~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports

 -- Martin <debacle@debian.org>  Tue, 08 Jun 2021 21:52:28 +0000

dino-im (0.2.0-3) unstable; urgency=critical

  * Fix file traversal issue on incoming file transfers (CVE-2021-33896)
  * Don't remove characters after '#' in filename
    Thanks to fiaxh (Dino upstream) for both patches!

 -- Martin <debacle@debian.org>  Mon, 07 Jun 2021 17:43:27 +0000

dino-im (0.2.0-2) unstable; urgency=medium

  * Add upstream patch to adjust Real for latest vala version
    (Closes: #985754)

 -- Martin <debacle@debian.org>  Mon, 22 Mar 2021 22:38:23 +0000

dino-im (0.2.0-1) unstable; urgency=medium

  * New upstream release with nice features:
    - Message correction: press cursor up key
    - File sharing: drag and drop
    - Encryption: better indication by lock and seal symbols
    - Unread: number of unread messages is displayed
    - Pending: "pending..." is displayed for unsent messages
    More information: https://dino.im/blog/2020/11/dino-0.2-release/
  * Add upstream signing key
  * Delete obsolete patch

 -- Martin <debacle@debian.org>  Fri, 13 Nov 2020 21:34:36 +0000

dino-im (0.1.0-5) unstable; urgency=medium

  * Fixes suggested by upstream:
    - move metainfo to dino-im, and actually install .service file

 -- Martin <debacle@debian.org>  Tue, 23 Jun 2020 22:34:27 +0000

dino-im (0.1.0-4) unstable; urgency=medium

  * Fixes suggested by upstream:
    - add appdata metainfo
    - rename dino to dino-im in .service file, too
    - do not enable notification-sound plugin

 -- Martin <debacle@debian.org>  Tue, 26 May 2020 23:50:36 +0000

dino-im (0.1.0-3) unstable; urgency=medium

  * Fix broken upload, too late for dcut...

 -- Martin <debacle@debian.org>  Mon, 11 May 2020 08:43:46 +0000

dino-im (0.1.0-2) unstable; urgency=medium

  * Allow newer libsignal >= 2.3.2 (Closes: #960238)

 -- Martin <debacle@debian.org>  Mon, 11 May 2020 07:55:14 +0000

=== debian/control ===
Source: dino-im
Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
Uploaders: Martin <debacle@debian.org>
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 11),
	cmake,
	dh-exec,
	gettext,
	libgcrypt20-dev,
	libgee-0.8-dev,
	libglib2.0-dev,
	libgpgme-dev,
	libgtk-3-dev (>= 3.22),
	libnotify-dev,
	libqrencode-dev,
	libsignal-protocol-c-dev (>= 2.3.2~),
	libsoup2.4-dev,
	libsqlite3-dev,
	ninja-build,
	valac
Standards-Version: 4.1.4
Rules-Requires-Root: no
Homepage: https://github.com/dino/dino
Vcs-Browser: https://salsa.debian.org/xmpp-team/dino-im
Vcs-Git: https://salsa.debian.org/xmpp-team/dino-im.git

Package: dino-im
Architecture: any
Depends: ${misc:Depends},
	${shlibs:Depends},
	dino-im-common (= ${source:Version})
Recommends: ca-certificates,
	dbus,
	fonts-noto-color-emoji,
	network-manager
Breaks: dino-im-common (<< 0.1.0-5~)
Replaces: dino-im-common (<< 0.1.0-5~)
Description: modern XMPP client
 Dino is a modern XMPP client with a nice and clean look.
 It does support OMEMO and OpenPGP for end-to-end encryption.
 If you are looking for a Conversations look-alike, this
 program might be for you.

Package: dino-im-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: dino-im (<< 0.1.0-5~)
Description: modern XMPP client - common files
 Dino is a modern XMPP client with a nice and clean look.
 It does support OMEMO and OpenPGP for end-to-end encryption.
 If you are looking for a Conversations look-alike, this
 program might be for you.
 .
 This package contains platform independent files.

## dino-im 0.2.1%2Bgit20210824.93e2e0d

=== debian/changelog ===
dino-im (0.2.1+git20210824.93e2e0d-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Martin <debacle@debian.org>  Fri, 03 Sep 2021 18:25:25 +0000

dino-im (0.2.1+git20210824.93e2e0d-1) unstable; urgency=critical

  [ Taowa ]
  * new upstream release, as well as several patches
    - notably adds support for audio and video calls!
    - also fixes a bug causing crashes on launch (closes: #992627)
  * added myself to uploaders

  [ Martin ]
  * removed patches that have been merged upstream
  * add new build dependencies


 -- Taowa <taowa@debian.org>  Wed, 01 Sep 2021 12:00:00 -0400

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: dino-im
 Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
-Uploaders: Martin <debacle@debian.org>
+Uploaders: Martin <debacle@debian.org>,
+           Taowa <taowa@debian.org>
 Section: net
 Priority: optional
 Build-Depends: debhelper-compat (= 11),
@@ -11,12 +12,18 @@
 	libgee-0.8-dev,
 	libglib2.0-dev,
 	libgpgme-dev,
+	libgspell-1-dev,
+	libgstreamer1.0-dev,
+	libgstreamer-plugins-base1.0-dev,
 	libgtk-3-dev (>= 3.22),
+	libnice-dev,
 	libnotify-dev,
 	libqrencode-dev,
 	libsignal-protocol-c-dev (>= 2.3.2~),
 	libsoup2.4-dev,
 	libsqlite3-dev,
+	libsrtp2-dev,
+	libwebrtc-audio-processing-dev,
 	ninja-build,
 	valac
 Standards-Version: 4.1.4

## dino-im 0.2.1%2bgit20210607.ce292d0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,16 +2,16 @@
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
 include(ComputeVersion)
 if (NOT VERSION_FOUND)
-    project(Dino LANGUAGES C)
+    project(Dino LANGUAGES C CXX)
 elseif (VERSION_IS_RELEASE)
-    project(Dino VERSION ${VERSION_FULL} LANGUAGES C)
+    project(Dino VERSION ${VERSION_FULL} LANGUAGES C CXX)
 else ()
-    project(Dino LANGUAGES C)
+    project(Dino LANGUAGES C CXX)
     set(PROJECT_VERSION ${VERSION_FULL})
 endif ()
 
 # Prepare Plugins
-set(DEFAULT_PLUGINS omemo;openpgp;http-files)
+set(DEFAULT_PLUGINS omemo;openpgp;http-files;ice;rtp)
 foreach (plugin ${DEFAULT_PLUGINS})
     if ("$CACHE{DINO_PLUGIN_ENABLED_${plugin}}" STREQUAL "")
         if (NOT DEFINED DINO_PLUGIN_ENABLED_${plugin}})
@@ -96,6 +96,7 @@
     endif ()
 endmacro()
 
+
 if ("Ninja" STREQUAL ${CMAKE_GENERATOR})
     AddCFlagIfSupported(CMAKE_C_FLAGS -fdiagnostics-color)
 endif ()
@@ -105,6 +106,7 @@
 AddCFlagIfSupported(CMAKE_C_FLAGS -Wextra)
 AddCFlagIfSupported(CMAKE_C_FLAGS -Werror=format-security)
 AddCFlagIfSupported(CMAKE_C_FLAGS -Wno-duplicate-decl-specifier)
+AddCFlagIfSupported(CMAKE_C_FLAGS -fno-omit-frame-pointer)
 
 if (NOT VALA_WARN)
   set(VALA_WARN "conversion")
@@ -201,6 +203,7 @@
 add_subdirectory(xmpp-vala)
 add_subdirectory(libdino)
 add_subdirectory(main)
+add_subdirectory(crypto-vala)
 add_subdirectory(plugins)
 
 # uninstall target

=== main/CMakeLists.txt ===
--- 
+++ 
@@ -5,11 +5,14 @@
 
 find_packages(MAIN_PACKAGES REQUIRED
     Gee
+    Gst
+    GstVideo
     GLib
     GModule
     GObject
     GTK3
     ICU
+    Gspell
 )
 
 set(RESOURCE_LIST
@@ -20,7 +23,14 @@
     icons/dino-emoticon-symbolic.svg
     icons/dino-qr-code-symbolic.svg
     icons/dino-security-high-symbolic.svg
+    icons/dino-microphone-off-symbolic.svg
+    icons/dino-microphone-symbolic.svg
     icons/dino-party-popper-symbolic.svg
+    icons/dino-phone-hangup-symbolic.svg
+    icons/dino-phone-in-talk-symbolic.svg
+    icons/dino-phone-missed-symbolic.svg
+    icons/dino-phone-ring-symbolic.svg
+    icons/dino-phone-symbolic.svg
     icons/dino-status-away.svg
     icons/dino-status-chat.svg
     icons/dino-status-dnd.svg
@@ -28,6 +38,8 @@
     icons/im.dino.Dino.svg
     icons/im.dino.Dino-symbolic.svg
     icons/dino-tick-symbolic.svg
+    icons/dino-video-off-symbolic.svg
+    icons/dino-video-symbolic.svg
 
     icons/dino-device-desktop-symbolic.svg
     icons/dino-device-phone-symbolic.svg
@@ -45,6 +57,8 @@
     add_conversation/conference_details_fragment.ui
     add_conversation/list_row.ui
     add_conversation/select_jid_fragment.ui
+
+    call_widget.ui
     chat_input.ui
     contact_details_dialog.ui
     conversation_list_titlebar.ui
@@ -107,7 +121,8 @@
     src/ui/conversation_view_controller.vala
     src/ui/file_send_overlay.vala
     src/ui/global_search.vala
-    src/ui/notifications.vala
+    src/ui/notifier_freedesktop.vala
+    src/ui/notifier_gnotifications.vala
     src/ui/settings_dialog.vala
     src/ui/main_window.vala
     src/ui/main_window_controller.vala
@@ -122,12 +137,20 @@
     src/ui/add_conversation/select_contact_dialog.vala
     src/ui/add_conversation/select_jid_fragment.vala
 
+    src/ui/call_window/audio_settings_popover.vala
+    src/ui/call_window/call_bottom_bar.vala
+    src/ui/call_window/call_encryption_button.vala
+    src/ui/call_window/call_window.vala
+    src/ui/call_window/call_window_controller.vala
+    src/ui/call_window/video_settings_popover.vala
+
     src/ui/chat_input/chat_input_controller.vala
     src/ui/chat_input/chat_text_view.vala
     src/ui/chat_input/edit_history.vala
     src/ui/chat_input/encryption_button.vala
     src/ui/chat_input/occupants_tab_completer.vala
     src/ui/chat_input/smiley_converter.vala
+    src/ui/chat_input/spell_checker.vala
     src/ui/chat_input/view.vala
 
     src/ui/contact_details/blocking_provider.vala
@@ -139,6 +162,7 @@
     src/ui/conversation_selector/conversation_selector_row.vala
     src/ui/conversation_selector/conversation_selector.vala
 
+    src/ui/conversation_content_view/call_widget.vala
     src/ui/conversation_content_view/chat_state_populator.vala
     src/ui/conversation_content_view/content_populator.vala
     src/ui/conversation_content_view/conversation_item_skeleton.vala
@@ -150,6 +174,7 @@
     src/ui/conversation_content_view/message_widget.vala
     src/ui/conversation_content_view/subscription_notification.vala
 
+    src/ui/conversation_titlebar/call_entry.vala
     src/ui/conversation_titlebar/menu_entry.vala
     src/ui/conversation_titlebar/occupants_entry.vala
     src/ui/conversation_titlebar/search_entry.vala

=== plugins/CMakeLists.txt ===
if(DINO_PLUGIN_ENABLED_http-files)
  add_subdirectory(http-files)
endif(DINO_PLUGIN_ENABLED_http-files)

if(DINO_PLUGIN_ENABLED_ice)
  add_subdirectory(ice)
endif(DINO_PLUGIN_ENABLED_ice)

if(DINO_PLUGIN_ENABLED_rtp)
  add_subdirectory(rtp)
endif(DINO_PLUGIN_ENABLED_rtp)

if(DINO_PLUGIN_ENABLED_openpgp)
  add_subdirectory(gpgme-vala)
  add_subdirectory(openpgp)
endif(DINO_PLUGIN_ENABLED_openpgp)

if(DINO_PLUGIN_ENABLED_omemo)
  add_subdirectory(omemo)
  add_subdirectory(signal-protocol)
endif(DINO_PLUGIN_ENABLED_omemo)

if(DINO_PLUGIN_ENABLED_notification-sound)
  add_subdirectory(notification-sound)
endif(DINO_PLUGIN_ENABLED_notification-sound)

=== xmpp-vala/CMakeLists.txt ===
--- 
+++ 
@@ -20,13 +20,20 @@
 
 vala_precompile(ENGINE_VALA_C
 SOURCES
+    "src/core/direct_tls_xmpp_stream.vala"
+    "src/core/io_xmpp_stream.vala"
+    "src/core/module_flag.vala"
+    "src/core/starttls_xmpp_stream.vala"
+    "src/core/stream_connect.vala"
+    "src/core/tls_xmpp_stream.vala"
+    "src/core/xmpp_stream.vala"
+
     "src/core/namespace_state.vala"
     "src/core/stanza_attribute.vala"
     "src/core/stanza_node.vala"
     "src/core/stanza_reader.vala"
     "src/core/stanza_writer.vala"
     "src/core/xmpp_log.vala"
-    "src/core/xmpp_stream.vala"
 
     "src/module/bind.vala"
     "src/module/bookmarks_provider.vala"
@@ -48,22 +55,24 @@
     "src/module/stanza.vala"
     "src/module/stanza_error.vala"
     "src/module/stream_error.vala"
-    "src/module/tls.vala"
     "src/module/util.vala"
 
     "src/module/xep/0048_bookmarks.vala"
     "src/module/xep/0048_conference.vala"
     "src/module/xep/0402_bookmarks2.vala"
     "src/module/xep/0004_data_forms.vala"
+
     "src/module/xep/0030_service_discovery/flag.vala"
     "src/module/xep/0030_service_discovery/identity.vala"
     "src/module/xep/0030_service_discovery/info_result.vala"
     "src/module/xep/0030_service_discovery/item.vala"
     "src/module/xep/0030_service_discovery/items_result.vala"
     "src/module/xep/0030_service_discovery/module.vala"
+
     "src/module/xep/0045_muc/flag.vala"
     "src/module/xep/0045_muc/module.vala"
     "src/module/xep/0045_muc/status_code.vala"
+
     "src/module/xep/0047_in_band_bytestreams.vala"
     "src/module/xep/0049_private_xml_storage.vala"
     "src/module/xep/0054_vcard/module.vala"
@@ -75,13 +84,42 @@
     "src/module/xep/0084_user_avatars.vala"
     "src/module/xep/0085_chat_state_notifications.vala"
     "src/module/xep/0115_entity_capabilities.vala"
-    "src/module/xep/0166_jingle.vala"
+
+    "src/module/xep/0166_jingle/content.vala"
+    "src/module/xep/0166_jingle/content_description.vala"
+    "src/module/xep/0166_jingle/content_node.vala"
+    "src/module/xep/0166_jingle/content_security.vala"
+    "src/module/xep/0166_jingle/content_transport.vala"
+    "src/module/xep/0166_jingle/component.vala"
+    "src/module/xep/0166_jingle/jingle_flag.vala"
+    "src/module/xep/0166_jingle/jingle_module.vala"
+    "src/module/xep/0166_jingle/jingle_structs.vala"
+    "src/module/xep/0166_jingle/reason_element.vala"
+    "src/module/xep/0166_jingle/session.vala"
+    "src/module/xep/0166_jingle/session_info.vala"
+
+    "src/module/xep/0167_jingle_rtp/content_parameters.vala"
+    "src/module/xep/0167_jingle_rtp/content_type.vala"
+    "src/module/xep/0167_jingle_rtp/jingle_rtp_module.vala"
+    "src/module/xep/0167_jingle_rtp/payload_type.vala"
+    "src/module/xep/0167_jingle_rtp/session_info_type.vala"
+    "src/module/xep/0167_jingle_rtp/stream.vala"
+
+    "src/module/xep/0176_jingle_ice_udp/candidate.vala"
+    "src/module/xep/0176_jingle_ice_udp/jingle_ice_udp_module.vala"
+    "src/module/xep/0176_jingle_ice_udp/transport_parameters.vala"
+
+    "src/module/xep/0384_omemo/omemo_encryptor.vala"
+    "src/module/xep/0384_omemo/omemo_decryptor.vala"
+
     "src/module/xep/0184_message_delivery_receipts.vala"
     "src/module/xep/0191_blocking_command.vala"
     "src/module/xep/0198_stream_management.vala"
     "src/module/xep/0199_ping.vala"
     "src/module/xep/0203_delayed_delivery.vala"
+    "src/module/xep/0215_external_service_discovery.vala"
     "src/module/xep/0234_jingle_file_transfer.vala"
+    "src/module/xep/0249_direct_muc_invitations.vala"
     "src/module/xep/0260_jingle_socks5_bytestreams.vala"
     "src/module/xep/0261_jingle_in_band_bytestreams.vala"
     "src/module/xep/0280_message_carbons.vala"
@@ -89,9 +127,9 @@
     "src/module/xep/0313_message_archive_management.vala"
     "src/module/xep/0333_chat_markers.vala"
     "src/module/xep/0334_message_processing_hints.vala"
+    "src/module/xep/0353_jingle_message_initiation.vala"
     "src/module/xep/0359_unique_stable_stanza_ids.vala"
     "src/module/xep/0363_http_file_upload.vala"
-    "src/module/xep/0368_srv_records_tls.vala"
     "src/module/xep/0380_explicit_encryption.vala"
     "src/module/xep/0391_jingle_encrypted_transports.vala"
     "src/module/xep/0410_muc_self_ping.vala"
